<?php

add_shortcode( "premium-paypal-item", "add_pm_paypal_manager_plugin" );

function add_pm_paypal_manager_plugin( $atts ) {
	
	extract( shortcode_atts( array(
		'id' => ''
	), $atts ) );
	
	//Grab PayPal Manager settings
	$paypal_email = get_option('pm_paypal_payment_email', true);
	$payment_currency = get_option('pm_paypal_payment_currency', true);
	$pm_payment_currency_symbol = get_option('pm_payment_currency_symbol', true);
	$pm_paypal_product_return_url = get_option('pm_paypal_product_return_url', true);
	$pm_paypal_donation_return_url = get_option('pm_paypal_donation_return_url', true);
	$pm_paypal_product_identifier = get_option('pm_paypal_product_identifier', true);
	$pm_paypal_product_item_width = get_option('pm_paypal_product_item_width', true);
	$pm_paypal_product_item_responsive = get_option('pm_paypal_product_item_responsive', true);
	
	$currencySymbol = '';
	if( $pm_payment_currency_symbol == 'dollar' ) {
		$currencySymbol = '$';
	} else if($pm_payment_currency_symbol == 'euro') {
		$currencySymbol = '&euro;';
	} else if($pm_payment_currency_symbol == 'pound') {
		$currencySymbol = '&pound;';
	} else if($pm_payment_currency_symbol == 'japanese') {
		$currencySymbol = '&yen;';
	} else {
		//do nothing	
	}
	
	//Grab meta options
	
	//Payment type
	$pm_paypal_payment_type = get_post_meta( $id, 'pm_paypal_payment_type', true );
	
	//Donation Options
	$pm_paypal_donation_amount = get_post_meta( $id, 'pm_paypal_donation_amount', true );
	//$pm_paypal_donation_reference = get_post_meta( $id, 'pm_paypal_donation_reference', true );
	$pm_paypal_donation_placeholder = get_post_meta( $id, 'pm_paypal_donation_placeholder', true );
	
	//Payment Options
	$pm_paypal_payment_option1 = get_post_meta( $id, 'pm_paypal_payment_option1', true );
	$pm_paypal_payment_option2 = get_post_meta( $id, 'pm_paypal_payment_option2', true );
	$pm_paypal_payment_option3 = get_post_meta( $id, 'pm_paypal_payment_option3', true );
	$pm_paypal_payment_option4 = get_post_meta( $id, 'pm_paypal_payment_option4', true );
	$pm_paypal_payment_option5 = get_post_meta( $id, 'pm_paypal_payment_option5', true );
	$pm_paypal_payment_option6 = get_post_meta( $id, 'pm_paypal_payment_option6', true );
	
	$pm_paypal_payment_option1_price = get_post_meta( $id, 'pm_paypal_payment_option1_price', true );
	$pm_paypal_payment_option2_price = get_post_meta( $id, 'pm_paypal_payment_option2_price', true );
	$pm_paypal_payment_option3_price = get_post_meta( $id, 'pm_paypal_payment_option3_price', true );
	$pm_paypal_payment_option4_price = get_post_meta( $id, 'pm_paypal_payment_option4_price', true );
	$pm_paypal_payment_option5_price = get_post_meta( $id, 'pm_paypal_payment_option5_price', true );
	$pm_paypal_payment_option6_price = get_post_meta( $id, 'pm_paypal_payment_option6_price', true );
	
	//Product Options
	$pm_paypal_product_availablity = get_post_meta( $id, 'pm_paypal_product_availablity', true );
	$pm_paypal_product_code = get_post_meta( $id, 'pm_paypal_product_code', true );
	
	//Sandbox Options
	$pm_paypal_sandbox_mode = get_option('pm_paypal_sandbox_mode', true);
	$pm_paypal_merchant_sandbox_email = get_option('pm_paypal_merchant_sandbox_email', true);
	
	$paymentText = array();
	array_push(
				$paymentText, 
				$pm_paypal_payment_option1,
				$pm_paypal_payment_option2,
				$pm_paypal_payment_option3,
				$pm_paypal_payment_option4,
				$pm_paypal_payment_option5,
				$pm_paypal_payment_option6
	);
	
	$payments = array();
	array_push(
				$payments, 
				$pm_paypal_payment_option1_price,
				$pm_paypal_payment_option2_price,
				$pm_paypal_payment_option3_price,
				$pm_paypal_payment_option4_price,
				$pm_paypal_payment_option5_price,
				$pm_paypal_payment_option6_price
	);
	
	$totalPaymentOptions = 0;
		
	//pass plugin data and/or additional settings to JS
	//wp_enqueue_script( 'js_handler', plugins_url() ); //pass in second parameter to prevent error
	//wp_localize_script( 'js_handler', 'plugin_settings', $settings, true );
	//wp_localize_script( 'js_handler', 'plugin_data', json_decode($panels, true) ); 
	
	//Pass plugin URL to JS for Ajax purposes
	//$bloginfo = site_url();
	//wp_localize_script( 'js_handler', 'plugin_url', $bloginfo, true ); 
	
	
	//Add front-end code here
	
	//Method to retrieve a single post
	$queried_post = get_post($id);
	$GetTitle = addslashes($queried_post->post_title);
	$title = htmlspecialchars($GetTitle);
	$content = $queried_post->post_content;
	$image = get_the_post_thumbnail($id);
		
	?>
    
    <?php if($pm_paypal_payment_type == 'Product') {
		
			$html = '<div class="pm_paypal_item_container" style="width:'. ($pm_paypal_product_item_responsive == 'Yes' ? '100%' : $pm_paypal_product_item_width .'px').';">';
			
			$html .= '<div class="pm_paypal_item_img">'.$image.'</div>';
						
			$html .= '<div class="pm_paypal_item_content">';
			
				$html .= '<p><strong>'.stripslashes($title).'</strong></p>';
				$html .= '<p><b> '.__( 'Availability:', 'pmLocalization' ).' </b> '.$pm_paypal_product_availablity.' </p>';
			
				if($pm_paypal_product_code != '') {
					$html .= '<p><b>'. __( $pm_paypal_product_identifier, 'pmLocalization' ).' </b> '.$pm_paypal_product_code.' </p>';
				}
				
			
				if($pm_paypal_product_availablity == 'In Stock' || $pm_paypal_product_availablity == 'Pre-Order'){
					
					foreach($payments as $payment){
								
						if($payment != ''){
							$totalPaymentOptions++;
						}
						
					}//end of foreach
					
					if($totalPaymentOptions > 1){ //display select list
					
						$html .= '<select name="pm_paypal_item_price_list_'.$id.'" id="pm_paypal_item_price_list_'.$id.'">';
						
						$counter = 0;
						
						foreach($payments as $payment){
								
							//check to make sure payment is not blank (this will eliminate empty values in the select list)
							if($payment != ''){
								
								if($paymentText[$counter] != ''){
									//append text to price
									$html .= '<option value="'.$payment.'" title="'.$paymentText[$counter].'">'. $paymentText[$counter] .' - '. $currencySymbol . $payment.'</option>';
								} else {
									//show price only
									$html .= '<option value="'.$payment.'">'. $currencySymbol . $payment.'</option>';	
								}
																		
							}
							
							$counter++;
							
						}//end of foreach
						
						$html .= '</select>';
						
					
					} else {//display single price only
					
						if($pm_paypal_payment_option1 != ''){
							$html .= '<p><strong>'. $pm_paypal_payment_option1 .' - '. $currencySymbol . $pm_paypal_payment_option1_price. '</strong></p>';
						} else {
							$html .= '<p><strong>'. $currencySymbol . $pm_paypal_payment_option1_price. '</strong></p>';
						}
					
					}//end of $totalPaymentOptions
					
				}//end of stock check
				
			
				$html .= '<p>'.$content.'</p>';
			
				if($pm_paypal_product_availablity == 'In Stock' || $pm_paypal_product_availablity == 'Pre-Order'){
					
					//Paypal form
					if($pm_paypal_sandbox_mode == 'Yes') {
						$html .= '<form name="_xclick" action="https://www.sandbox.paypal.com/cgi-bin/webscr" method="post" id="pm_paypal_manager_form_'.$id.'">';
					} else {
						$html .= '<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" id="pm_paypal_manager_form_'.$id.'">';
					}//end of if
					
					$html .= '<input type="hidden" name="cmd" value="_xclick">';
					
					if($pm_paypal_sandbox_mode == 'Yes') {
						$html .= '<input type="hidden" name="business" value="'.$pm_paypal_merchant_sandbox_email.'">';
					} else {
						$html .= '<input type="hidden" name="business" value="'.$paypal_email.'">';
					}//end of if
					
					$html .= '<input type="hidden" name="currency_code" value="'.$payment_currency.'">';
					$html .= '<input type="hidden" name="item_name" value="">';
					$html .= '<input type="hidden" name="amount" value="">';
					$html .= '<input type="hidden" name="return" value="'.$pm_paypal_product_return_url.'" />';
					$html .= '<input type="hidden" name="email" value="" />';
					
					$html .= '</form>';
					
					$html .= '<input type="image" id="pm_paypal_buy_btn_'.$id.'" src="'.plugin_dir_url(__FILE__).'front-end/img/paypal_buynow.gif" style="background:none !important;" border="0" name="submit" alt="Make payments with PayPal - it\'s fast, free and secure!">';
					
				}//end of if
			
				$html .= '</div>';
				
				//render js if product is in-stock or pre-order
				if($pm_paypal_product_availablity == 'In Stock' || $pm_paypal_product_availablity == 'Pre-Order'){
					
					$html .= '<script type="text/javascript">';
					
					$html .= '(function($) {';
					
						$html .= ' $(document).ready(function(e) {';
						
							$html .= 'var paymentType = "'.$pm_paypal_payment_type.'";';
							$html .= 'var totalPaymentOptions = '.$totalPaymentOptions.';';
							$html .= 'var id = '.$id.';';
							
							$html .= "$('#pm_paypal_buy_btn_' + id).click(function(e){";
							
							$html .= 'e.preventDefault();';
							
							$html .= 'if(totalPaymentOptions > 1){';
								$html .= "var price = $('#pm_paypal_item_price_list_' + id).val().toString();";
								$html .= "var titleAddon = $('#pm_paypal_item_price_list_' + id).find(\"option:selected\").attr('title');";
								$html .= "$('input[name=item_name]').val(' ".$title." ' + (titleAddon != undefined ? ' - ' + titleAddon : '') );";
							$html .= '} else {';
								$html .= "var price = $pm_paypal_payment_option1_price;";
								$html .= "$('input[name=item_name]').val('$title');";
							$html .= '}';
							
							$html .= "$('input[name=amount]').val(price);";
							$html .= "$('#pm_paypal_manager_form_' + id).submit();";
						
							$html .= '});';
							
						$html .= '});';
						
					$html .= '})(jQuery);';
						
					$html .= '</script>';
					
				}//end of js check
			
			$html .= '</div>';
						
			return $html;
			
		}
		
	?>
    
    
    
    
    <?php
	
		if($pm_paypal_payment_type == 'Donation') {
			
			$html = '<div class="pm_paypal_item_container" style="width:'. ($pm_paypal_product_item_responsive == 'Yes' ? '100%' : $pm_paypal_product_item_width .'px').';">';
					
				$html .= '<div class="pm_paypal_item_img">'.$image.'</div>';
				
				//check first to see if we have more than one payment option
				foreach($payments as $payment){
					
					if($payment != ''){
						$totalPaymentOptions++;
					}
					
				}//end of foreach
				
				if( $pm_paypal_donation_amount == 'No' ){
				
					if($totalPaymentOptions > 1){
						
						$html .= '<select name="pm_paypal_item_price_list_'.$id.'" id="pm_paypal_item_price_list_'.$id.'">';
						
						$counter = 0;
						
						foreach($payments as $payment){
								
							//check to make sure payment is not blank (this will eliminate empty values in the select list)
							if($payment != ''){
								
								if($paymentText[$counter] != ''){
									//append text to price
									$html .= '<option value="'.$payment.'" title="'.$paymentText[$counter].'">'. $paymentText[$counter] .' - '. $currencySymbol . $payment.'</option>';
								} else {
									//show price only
									$html .= '<option value="'.$payment.'">'.$currencySymbol . $payment.'</option>';	
								}
																		
							}
							
							$counter++;
							
						}//end of foreach
						
						$html .= '</select>';
						
					} else {//display single price
						
						$html .= '<p><strong>'.$currencySymbol . $pm_paypal_payment_option1_price.'</strong></p>';
						
					}
						
				}//end of other amount check
				
				$html .= '<p>'.$content.'</p>';
				
				//Paypal form
				if($pm_paypal_sandbox_mode == 'Yes') {
					$html .= '<form name="_xclick" action="https://www.sandbox.paypal.com/cgi-bin/webscr" method="post" id="pm_paypal_manager_form_'.$id.'">';
				} else {
					$html .= '<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" id="pm_paypal_manager_form_'.$id.'">';
				}
				
				$html .= '<input type="hidden" name="cmd" value="_xclick">';
				
				if($pm_paypal_sandbox_mode == 'Yes') {
					$html .= '<input type="hidden" name="business" value="'.$pm_paypal_merchant_sandbox_email.'" />';
				} else {
					$html .= '<input type="hidden" name="business" value="'.$paypal_email.'" />';
				}
				
				$html .= '<input type="hidden" name="currency_code" value="'.$payment_currency.'" />';
				$html .= '<input type="hidden" name="item_name" value="" />';
				$html .= '<input type="hidden" name="amount" value="" />';
				$html .= '<input type="hidden" name="return" value="'.$pm_paypal_donation_return_url.'" />';
				$html .= '<input type="hidden" name="email" value="" />';
				
				$html .= '</form>';
				
				if($pm_paypal_donation_amount == 'Yes') {
					
					$html .= '<div class="pm_paypal_donate_amount">';
						$html .= '<input type="text" name="pm_paypal_donation_amount_'.$id.'" id="pm_paypal_donation_amount_'.$id.'" placeholder="'.$pm_paypal_donation_placeholder.'"/>';
					$html .= '</div>';
					
				}
				
				$html .= '<input type="image" id="pm_paypal_buy_btn_'.$id.'" style="background:none !important; padding:0; border-radius:none !important;" alt="Make donations with PayPal - it\'s fast, free and secure!" name="submit" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif">';
				
				$html .= '<script type="text/javascript">';
				
					$html .= '(function($) {';
					
						$html .= ' $(document).ready(function(e) {';
						
							$html .= 'var paymentType = "'.$pm_paypal_payment_type.'";';
							$html .= 'var totalPaymentOptions = '.$totalPaymentOptions.';';
							$html .= 'var donationAmount = "'.$pm_paypal_donation_amount.'";';
							$html .= 'var id = '.$id.';';
							
							$html .= "$('#pm_paypal_buy_btn_' + id).click(function(e){";
													
								$html .= 'e.preventDefault();';
								
								$html .= 'if(totalPaymentOptions > 1){';
									
									$html .= "var price = $('#pm_paypal_item_price_list_' + id).val().toString();";
									$html .= "var titleAddon = $('#pm_paypal_item_price_list_' + id).find(\"option:selected\").attr('title');";
									$html .= "$('input[name=item_name]').val('".$title." - $' + price );";
									
								$html .= "} else if(donationAmount == 'Yes') {";
									
									$html .= "var price = $('#pm_paypal_donation_amount_' + id).val().toString();";
									$html .= "$('input[name=item_name]').val('".$title." - $' + price);";
									
								$html .= '} else {';
									$html .= "var price = '$pm_paypal_payment_option1_price';";
									$html .= "$('input[name=item_name]').val('".$title."');";
								$html .= '}';
															
								$html .= "$('input[name=amount]').val(price);";
								$html .= "$('#pm_paypal_manager_form_' + id).submit();";
														
							$html .= '});';
						
						$html .= '});';
					
					$html .= '})(jQuery);';
					
				$html .= '</script>';
				
			
			$html .= '</div><!-- /pm_paypal_item_container -->';
			
			return $html;
			
		}//end of donation check if
	
}//end of function

?>